/**************************************************************

File Name:		Complex_Vector_Multiply_Accumulate_test.asm
		
Date Modified:	01/05/99	RFG
				05/01/00	RFG

Description:	Program to call Complex_Vector_Multiply_Accumulate.asm

**************************************************************/

#include    "def21364.h"				/* Symbol Definition File */

#define		N		4096				/* number of samples */

.extern cx_vec_mult_accum;

/* DM data */
.section/dm seg_dmda;					/* Segments are declared in the .ldf file*/
.ALIGN 2;
.var    x_input[2*N] = "indata1.dat";	/* input array of complex samples (interleaved: real[0],imag[0],real[1],imag[1]) for input data */
.ALIGN 2;
.var    accum[2*N+4];					/* output array of accumulated result; complex data (interleaved: real[0],imag[0],real[1],imag[1] */


/* PM data */
.section/dm seg_pmda;
.ALIGN 2;
.var    y_input[2*N] = "indata2.dat";	/* input array of complex samples (interleaved: real[0],imag[0],real[1],imag[1]) for input data */


/* PM interrupt vector code */
.section/pm   seg_rth;
Reserved_1:     rti; nop; nop; nop;
Chip_Reset:     idle; jump start; nop; nop;


/* program memory code */
.section/pm seg_pmco;

start:

/*--------------------- Setup modify registers for arrays --------------------*/
	m0 = 2;
	m1 = 1;
	m2 = -3;
	m3 = 3;
	
	m8 = 2;
/*----------------------------------------------------------------------------*/



/*--------- Setup DAGs for input/output and call cx_vec_mult_accum -----------*/
	r0 = x_input;
	r0 = lshift r0 by -1;			/* set i0 to x_input in long-word space */
	b0 = r0;
	l0 = 0;
	
	r0 = r0 + 1;					/* set i1 to x_input + 1 in long-word space */
	b1 = r0;
	l1 = 0;

	r0 = y_input;
	r0 = lshift r0 by -1;			/* set i9 to y_input in long-word space */
	b9 = r0;
	l9 = 0;
	
	r0 = r0 + 1;					/* set i8 to y_input + 1 in long-word space */
	b8 = r0;
	l8 = 0;

	r0 = accum + 4;
	r0 = lshift r0 by -1;			/* set i2 to output in long-word space */
	b2 = r0;
	l2 = 0;

	call cx_vec_mult_accum (db);
	r2 = N/2+1;
	nop;
/*----------------------------------------------------------------------------*/

/* call it again with same inputs to test accumulation */

/*--------- Setup DAGs for input/output and call cx_vec_mult_accum -----------*/
	
	i0 = b0;			/* set i0 to x_input in long-word space */
	
	i1 = b1;			/* set i1 to x_input + 1 in long-word space */
	
	i9 = b9;			/* set i9 to y_input in long-word space */
	
	i8 = b8;			/* set i8 to y_input + 1 in long-word space */
	
	i2 = b2;			/* set i2 to output in long-word space */
	
	call cx_vec_mult_accum (db);
	r2 = N/2+1;
	nop;
/*----------------------------------------------------------------------------*/


	  
/* Terminate and wait */
wait1:	idle;
		jump wait1;
